--=========================================================
--
-- 自キャラクラス
--
--=========================================================
PlayerChar = {}
PlayerChar.new = function ( params )
	
	local this = {}
	this.className = "PlayerChar"
	this.params = params

	this.spriteSheet = spriteSheet_zunko
	
	SPRITE_WIDTH = 32
	SPRITE_HEIGHT = 32
	
	this.spriteQuads = {}
	
	this.spriteQuads [ UP ] = {}
	this.spriteQuads [ UP ][1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ UP ][2] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ UP ][3] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ UP ][4] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )

	this.spriteQuads [ RIGHT ] = {}
	this.spriteQuads [ RIGHT ][1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ RIGHT ][2] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ RIGHT ][3] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ RIGHT ][4] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )

	this.spriteQuads [ DOWN ] = {}
	this.spriteQuads [ DOWN ][1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ DOWN ][2] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ DOWN ][3] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ DOWN ][4] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )

	this.spriteQuads [ LEFT ] = {}
	this.spriteQuads [ LEFT ][1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ LEFT ][2] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ LEFT ][3] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )
	this.spriteQuads [ LEFT ][4] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )


	
	this.x = WIDTH / 2
	this.y = HEIGHT / 2
	
	this.animationCount = 1
	this.animationCountWait = 0
	this.animationCountWaitMax = 10
	this.direction = DOWN
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		local speed = 3
		
		local isStop = true
		if ( love.keyboard.isDown ( "left"  ) ) then self.x = self.x - speed; self.direction = LEFT;  isStop = false end
		if ( love.keyboard.isDown ( "right" ) ) then self.x = self.x + speed; self.direction = RIGHT; isStop = false end
		if ( love.keyboard.isDown ( "up"    ) ) then self.y = self.y - speed; self.direction = UP;    isStop = false end
		if ( love.keyboard.isDown ( "down"  ) ) then self.y = self.y + speed; self.direction = DOWN;  isStop = false end
		
		if ( isStop ) then
			self.animationCount = 2
		else
			
			self.animationCountWait = self.animationCountWait + 1
			if ( self.animationCountWait >= self.animationCountWaitMax ) then
				self.animationCountWait = 0

				self.animationCount =  self.animationCount + 1
				if ( self.animationCount > #self.spriteQuads [self.direction] ) then
					self.animationCount = 1
				end
			end
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )

		local drawX = self.x - SPRITE_WIDTH/2
		local drawY = self.y - SPRITE_HEIGHT/2
		
		local quad = self.spriteQuads [self.direction][ self.animationCount ]
		
		love.graphics.draw ( self.spriteSheet, quad, drawX, drawY )
		

		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

