--=========================================================
--
-- ずんだ餅クラス
--
--=========================================================
Zunda = {}
Zunda.new = function ( params )
	
	local this = {}
	this.className = "Zunda"
	this.params = params
	
	this.spriteSheet = spriteSheet_zunda
	
	this.spriteQuads = {}
	this.spriteQuads[1] = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, this.spriteSheet:getDimensions() )

	this.x = this.params.x
	this.y = this.params.y
	
	this.isTaken = false
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)

		-- 自キャラとの当たり判定（距離判定）
		local distance = math.sqrt( (self.x - player.x)^2 + (self.y - player.y)^2 )
		
		-- 距離が一定以下なら取得とする
		if ( distance < 32 ) then
			self.isTaken = true
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)

		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )

		local drawX = self.x - SPRITE_WIDTH/2
		local drawY = self.y - SPRITE_HEIGHT/2
		
		local quad = self.spriteQuads[1]
		
		love.graphics.draw ( self.spriteSheet, quad, drawX, drawY )
		

		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

